clear all;
close all;

isTDT3=1;
isTDT2=0;
isNeuroamp=0;

WavPath='D:\ASSR\test\';
WavNameASSR='C57j';

isASSR=0;
ASSRModFreq=[312 642 814];
SetAttDBASSR=   [0  50 40 30 20 10 ];    % zu 80 dB
%AnzahlBlockASSR=[15 15 15 15 15 15 ];   % je 4 Sec    
AnzahlBlockASSR=[1 1 1 1 1 1 ];          % je 4 Sec    

isMTF=0;
SetAttDBSMax=[15];  % zu 95 dB
WavNameMTF='MTF1';

isASSRMultiFreq=1;

isOnlineFFT=0;

MedusaHP=60;
NoiseRange=10;    % for noise calculation
ASSRrange=2;      % window to fMod for no noise 
MedusaGain=20;
TDT2Gain=50000;
FreqRA16BS=12207;
isPause=-1;

uiPause=uicontrol('Style','pushbutton','String','Pause','Position', [210 5 50 20],'Callback','isPause=isPause*-1; if (isPause>0) set(uiPause,''String'',''! Pause !''); else set(uiPause,''String'',''Pause''); end; drawnow');

CircuitNameRP1=   'ASSR_Stimulus_RP';
CircuitNameRP2=   'ASSR_Acquire_RP';  
CircuitNameMedusa='ASSR_Acquire_Medusa';

npts=48828; bufpts=npts/2;
StimAmp=      [5]; 
StimShft=     [5];
FreqMod=      [0];
AnzahlTrials=1;
dBStep=0;

if isASSR==1      
  AnzahlTrials=1;
  TragerFreq= [4000 7000 10000 15000 ]; SetAttFreqEich= [36.2 36.7 33.5 32.4 ]; dBbezug=80;   %B&K sinus+ 700 AMFR bei  80dB
  WavName=WavNameASSR;    
  SetAttDB=SetAttDBASSR;
  AnzahlBlock=AnzahlBlockASSR;
  sizeSetAttDB=size(SetAttDB);    
  sizeASSRModFreq=size(ASSRModFreq);
  sizeTragerFreq=size(TragerFreq);
  sizeASSRAmp=size(StimAmp);  
end;

if isMTF==1 
  SetAttDB=SetAttDBSMax; dBbezug=95;
  AnzahlBlock=[4];                             % je 4 Sec
  WavName=WavNameMTF;
  j=1; for i=110:29:1300 ASSRModFreq(j)=i; j=j+1; end;
  TragerFreq=[10000]; SetAttFreqEich=[18.5];   % zu 95 dB
  sizeASSRModFreq=size(ASSRModFreq);
  sizeTragerFreq=size(TragerFreq);
end;

if isASSRMultiFreq==1 
  dBbezug=80;
  SetAttDB=   [0  10 20 30 40 50 60 65 70];   % zu 80 dB    
% AnzahlBlock=[15 15 15 15 15 15 15 15 15 ];  % je 4 Sec
  AnzahlBlock=[1  1  1  1  1  1  1  1  1  ];  % je 4 Sec  
  WavName='C57M4k7k10k15k';
  sizeTragerFreq =[1 1];
  sizeASSRModFreq=[1 1];
  %ASSRModFMulti  =  [ 226  255  284   313];
  ASSRModFMulti  =  [ 690  545  574   610];
  TragerFreqMulti=  [ 4020 7060 10010 15005];
  ASSRAmpMulti   =  [ 2    2    2     2]; 
  ASSRShftMulti  =  ASSRAmpMulti;
  SizeASSRFreqMulti=size(ASSRModFMulti);
  SetAttFreqEichMulti=12;  
  CircuitNameRP1='ASSR_Stimulus_Multi_RP21'; 
  CircuitNameRP2='ASSR_Stimulus_Multi_RP22';
  FreqMod=  [0];  
  AnzahlTrials=1;
  npts=48828; bufpts=npts/2;
end;

if isOnlineFFT==1 
  npts=48828; bufpts=npts/2; dBStep=0;
  StimAmp=  [5]; 
  StimShft= [5];
  FreqMod=  [0];
  SetAttDB= [30];  SetAttFreqEich=[18.5];  
  ASSRModFreq= [427]; 
  TragerFreq=[12000];
  sizeASSRModFreq=size(ASSRModFreq);
  sizeTragerFreq=size(TragerFreq);
  CircuitNameMedusa='ASSR_Acquire_Medusa_Online';
  CircuitNameRP2='ASSR_Acquire_RP2_Online';  
  AnzahlBlock=1;   
end;

BitMaskGetStatus0=[
'Connection is not ok    '
'Circuit is not Loaded   '
'Circuit is not Running  '
'Battery Status is not ok'
'no clipping is occurring'
'no clip last GetStatus  '];
 
BitMaskGetStatus1=[
'Connection ok        '
'Circuit is Loaded    '
'Circuit is Running   '
'Battery Status ok    '
'clipping is occurring' 
'clip last GetStatus  '];

zBUS=actxcontrol('ZBUS.x',[1 1 1 1]); invoke(zBUS, 'connectZBUS','GB');for i=1:3 invoke(zBUS,'HardwareReset',uint16(i)); end
PA5x1=actxcontrol('PA5.x',[1 1 1 1]); invoke(PA5x1,'ConnectPA5','GB',1);invoke(PA5x1,'SetAtten',100);
PA5x2=actxcontrol('PA5.x',[1 1 1 1]); invoke(PA5x2,'ConnectPA5','GB',2);invoke(PA5x2,'SetAtten',100);


RP1=actxcontrol('RPco.x',[1 1 1 1]);invoke(RP1,'ClearCOF'); invoke(RP1,'ConnectRP2','GB',1);invoke(RP1,'LoadCOF',CircuitNameRP1); invoke(RP1,'Run');StatusRP1=invoke(RP1,'GetStatus');
for i=1:3 if bitget(uint16(StatusRP1),i) BitMaskGetStatus1(i,:);
  else BitMaskGetStatus0(i,:); 
  end; end;
FreqRP1=invoke(RP1,'GetSFreq')

RP2=actxcontrol('RPco.x',[1 1 1 1]);invoke(RP2,'ClearCOF'); invoke(RP2,'ConnectRP2','GB',2);invoke(RP2,'LoadCOF',CircuitNameRP2); invoke(RP2,'Run');StatusRP2=invoke(RP2,'GetStatus');
for i=1:3 if bitget(uint16(StatusRP2),i) BitMaskGetStatus1(i,:);
  else BitMaskGetStatus0(i,:); 
  end; end;
FreqRP2=invoke(RP2,'GetSFreq')

RA16BS=actxcontrol('RPco.x',[1 1 1 1]);invoke(RA16BS,'ClearCOF'); invoke(RA16BS,'ConnectRA16','GB',1);invoke(RA16BS,'LoadCOF',CircuitNameMedusa);invoke(RA16BS,'Run');StatusRA16=invoke(RA16BS,'GetStatus');
for i=1:5 if bitget(uint16(StatusRA16),i) BitMaskGetStatus1(i,:);
  else BitMaskGetStatus0(i,:);
  end; end;
invoke(RA16BS,'SetTagVal','MedusaHP',MedusaHP);
FreqRA16BS=invoke(RA16BS,'GetSFreq')
if invoke(RP1,'GetStatus')==7
  if isOnlineFFT==1
    if isNeuroamp==1
      t=double(1:npts)/double(FreqRP2);      
    else  
      t=double(1:npts)/double(FreqRA16BS);
    end;  
    while isOnlineFFT==1
      invoke(RP1,'SetTagVal','TragerFreq',TragerFreq(1));
      invoke(PA5x1,'SetAtten',SetAttFreqEich(1));
      invoke(RP1,'SetTagVal','ASSRModFreq',ASSRModFreq(1)*1.00000256);
      fx1=ASSRModFreq(1)-NoiseRange;
      fx2=ASSRModFreq(1)+NoiseRange;
 
      invoke(RP1,'SetTagVal','FreqMod',FreqMod(1));
      invoke(RP1,'SetTagVal','StimAmp',StimAmp(1));
      invoke(RP1,'SetTagVal','StimShft',StimShft(1));
      invoke(PA5x2,'SetAtten',SetAttDB(1));

      if (isPause==1) set(uiPause,'String','Wait'); drawnow; end; while (isPause==1) pause(2); end;              
      invoke(RP1,'SoftTrg',1);invoke(RP2,'SoftTrg',1);invoke(RA16BS,'SoftTrg',1); % start stimulus and Acquire
      for i=1:AnzahlBlock
        l=((i-1)*npts);
        
        if isNeuroamp==1
          curindex=invoke(RA16BS,'GetTagVal','index'); while(curindex<=bufpts) curindex=invoke(RP2,'GetTagVal','index'); pause(0.1); end;          
          ASSRDat(l+1:l+bufpts)=invoke(RP2,'ReadTagV','dataout',0, bufpts);
          curindex=invoke(RP2,'GetTagVal','index'); while(curindex>=bufpts) curindex=invoke(RP2,'GetTagVal','index'); pause(0.1); end;                    
          ASSRDat(l+bufpts+1:l+(2*bufpts))=invoke(RP2,'ReadTagV','dataout',bufpts,bufpts);                    
        else  
          curindex=invoke(RA16BS,'GetTagVal','index'); while(curindex<=bufpts) curindex=invoke(RA16BS,'GetTagVal','index'); pause(0.1); end;
          ASSRDat(l+1:l+bufpts)=invoke(RA16BS,'ReadTagV','dataout',0, bufpts);
          curindex=invoke(RA16BS,'GetTagVal','index'); while(curindex>=bufpts) curindex=invoke(RA16BS,'GetTagVal','index'); pause(0.1); end;          
          ASSRDat(l+bufpts+1:l+(2*bufpts))=invoke(RA16BS,'ReadTagV','dataout',bufpts,bufpts);
        end;  
        FFTSize=bufpts*i;
        FFTfx1=uint32(fx1/((FreqRA16BS/FFTSize))+1); 
        FFTfx2=uint32(fx2/((FreqRA16BS/FFTSize)));
        yFFT=fft(ASSRDat(1:FFTSize),FFTSize);Pyy=(sqrt(yFFT.*conj(yFFT))*2/FFTSize); tFFT=0:FFTSize-1; tFFT=tFFT*(FreqRA16BS/FFTSize);
        subplot(2,1,1);plot(tFFT(5:uint32(FFTSize/8)),Pyy(5:uint32(FFTSize/8)));
        xlabel('Frequency (Hz)','FontSize',10);ylabel('Amplitude (|V|)','FontSize',10);
        subplot(2,1,2);plot(t(1:uint32(FreqRP2/100)),ASSRDat(1:uint32(FreqRP2/100)));
        xlabel('Time (s)','FontSize',10);ylabel('Voltage (V)','FontSize',10);
      end;
      invoke(RA16BS,'SoftTrg',2);invoke(RP1,'SoftTrg',2); 
    end;  
  end;
  
  if (isASSR==1 | isASSRMultiFreq==1 |isMTF==1 )
    if isMTF==1
    else
      uiNextModFreq=uicontrol('Style','pushbutton','String','NextModFreq','Position', [10 5 90 20],'Callback','k=sizeSetAttDB(1,2);n=n+1;');
      uiNextTraegerFreq=uicontrol('Style','pushbutton','String','NextTrgerFreq','Position', [105 5 90 20],'Callback','n=sizeASSRModFreq(1,2);m=m+1;');
    end;  

    sizeASSRAmp=size(StimAmp);
    sizeSetAttDB=size(SetAttDB);

    Trials=sizeTragerFreq(1,2)*sizeASSRModFreq(1,2)*sizeASSRAmp(1,2)*sizeSetAttDB(1,2)*AnzahlTrials;

    pause(2);FirstT=clock;isTrial=0;isASSRtrack=0;    
    
    t=double(1:npts)/double(FreqRA16BS);
    
    for m=1:sizeTragerFreq(1,2)                                % configuration Trgerfrequenz
      if isASSRMultiFreq==0
        invoke(RP1,'SetTagVal','TragerFreq',TragerFreq(m));
        invoke(PA5x1,'SetAtten',SetAttFreqEich(m)); 
      else
        for i=1:2 invoke(RP1,'SetTagVal',['TragerFreq' int2str(i)],TragerFreqMulti(i)); end;
        for i=3:4 invoke(RP2,'SetTagVal',['TragerFreq' int2str(i)],TragerFreqMulti(i)); end;        
        invoke(PA5x1,'SetAtten',SetAttFreqEichMulti);
      end;
      for n=1:sizeASSRModFreq(1,2)                                % configuration ASSRModFreq
        if isASSRMultiFreq==0
          invoke(RP1,'SetTagVal','ASSRModFreq',ASSRModFreq(n)*1.00000256);
        else
          for i=1:2 invoke(RP1,'SetTagVal',['ASSRModFreq' int2str(i)],ASSRModFMulti(i)*1.00000256); end;
          for i=3:4 invoke(RP2,'SetTagVal',['ASSRModFreq' int2str(i)],ASSRModFMulti(i)*1.00000256); end;          
        end;
        for o=1:sizeASSRAmp(1,2)                               % configuration Amplitude
          invoke(RP1,'SetTagVal','FreqMod',FreqMod(o));
          if isASSRMultiFreq==0
            invoke(RP1,'SetTagVal','StimAmp',StimAmp(o));
            invoke(RP1,'SetTagVal','StimShft',StimShft(o));
          else
            for i=1:2 invoke(RP1,'SetTagVal',['StimAmp' int2str(i)],ASSRAmpMulti(i)); end;
            for i=3:4 invoke(RP2,'SetTagVal',['StimAmp' int2str(i)],ASSRAmpMulti(i)); end;            
            for i=1:2 invoke(RP1,'SetTagVal',['StimShft' int2str(i)],ASSRShftMulti(i));end;
            for i=3:4 invoke(RP2,'SetTagVal',['StimShft' int2str(i)],ASSRShftMulti(i));end;
          end;
          for j=1:AnzahlTrials

            isTrial=isTrial+1;                
            clear noiseArray ASSRDat;
            isFind=0; doFindExact=0;
            for k=1:sizeSetAttDB(1,2) % db Abschwchung
              isAttDB=SetAttDB(k); invoke(PA5x2,'SetAtten',isAttDB);
              if isASSRMultiFreq==0
                fileBody=strcat(WavPath,WavName,['-',int2str(j),'-',int2str(TragerFreq(m)),'-',int2str(ASSRModFreq(n)),'-',num2str(StimAmp(o)),'-',int2str(FreqMod(o)),'-',int2str(dBbezug-isAttDB),'-',int2str(FreqRA16BS),'-',int2str(MedusaHP)])
                fileASSR=[fileBody,'.asr'];
                filePrint=[fileBody,'.jpg'];
                fileFIG=[fileBody,'.fig'];
                fileExcel=strcat(WavPath,WavName);
              else
                StrTragerFreqMulti='';StrASSRFreqMulti='';
                for i=1:SizeASSRFreqMulti(1,2)-1
                  StrTragerFreqMulti=[StrTragerFreqMulti,int2str(TragerFreqMulti(i)),'_'];
                  StrASSRFreqMulti=[StrASSRFreqMulti,int2str(ASSRModFMulti(i)),'_'];
                end
                StrTragerFreqMulti=[StrTragerFreqMulti,int2str(TragerFreqMulti(SizeASSRFreqMulti(1,2)))];
                StrASSRFreqMulti=[StrASSRFreqMulti,int2str(ASSRModFMulti(SizeASSRFreqMulti(1,2)))];

                fileASSR=strcat(WavPath,WavName,['-',int2str(j),'-',...
                  StrTragerFreqMulti,'-',StrASSRFreqMulti,'-',...
                  num2str(StimAmp(o)),'-',int2str(FreqMod(o)),'-',int2str(dBbezug-isAttDB),'-',int2str(FreqRA16BS),'-',int2str(MedusaHP),'.asr'])
              end;              
              
              if (isPause==1) set(uiPause,'String','Wait'); drawnow; end; while (isPause==1) pause(2); end;              
              
              invoke(RP1,'SoftTrg',1);invoke(RP2,'SoftTrg',1);invoke(RA16BS,'SoftTrg',1);  % start stimulus and Acquire
              for i=1:AnzahlBlock(k);                       % numbers of time-blocks 
                l=((i-1)*npts);i
                if isTDT3==1
                  curindex=invoke(RA16BS,'GetTagVal','index'); while(curindex<=bufpts) curindex=invoke(RA16BS,'GetTagVal','index'); pause(0.5); end
                  ASSRDat(l+1:l+bufpts)=invoke(RA16BS,'ReadTagV','dataout',0, bufpts);
                end
                if isTDT2==1
                  curindex=invoke(RP2,'GetTagVal','index'); while(curindex<=bufpts) curindex=invoke(RP2,'GetTagVal','index'); pause(0.5); end
                  ASSRDat(l+1:l+bufpts)=invoke(RP2,'ReadTagV','datax',0, bufpts);
                end;  
                if isTDT3==1                
                  curindex=invoke(RA16BS,'GetTagVal','index'); while(curindex>=bufpts) curindex=invoke(RA16BS,'GetTagVal','index'); pause(0.5); end
                  ASSRDat(l+bufpts+1:l+(2*bufpts))=invoke(RA16BS,'ReadTagV','dataout',bufpts,bufpts);
                end  
              end
              invoke(RA16BS,'SoftTrg',2);invoke(RP1,'SoftTrg',2);invoke(RP2,'SoftTrg',2);  % stop and reset stimulus and Acquire
              
              if isTDT3==1 ASSRDat(:)=ASSRDat(:)/MedusaGain; end;
              if isTDT2==1 ASSRDat(:)=ASSRDat(:)/TDT2Gain; end;
              FData=fopen(fileASSR,'w');if FData>-1
                countASSRDat=fwrite(FData,ASSRDat(:),'float32'); fclose(FData);
              else Error=['Error open to write ',fileASSR]; end;
              FFTSize=countASSRDat;

              % Position [left bottom width height]
              h = uicontrol('Style','Text','String',fileASSR,'Position',[270 5 280 15]);
              s=[num2str(isASSRtrack),'  ',num2str(Trials)];h=uicontrol('Style','Text','String',s,'Position',[5 105 100 15]);

              if isASSRMultiFreq==0
                s=['TFreq  ',num2str(TragerFreq(m))];h=uicontrol('Style','Text','String',s,'Position', [5 90 100 15]);
                s=['MFreq  ',num2str(ASSRModFreq(n))];h=uicontrol('Style','Text','String',s,'Position',[5 75 100 15]);
              else
                s=['TFreq  ','Multi'];h=uicontrol('Style','Text','String',s,'Position',[5 90 100 15]);
                s=['MFreq  ','Multi'];h=uicontrol('Style','Text','String',s,'Position',[5 75 100 15]);
              end;
              s=[num2str(StimAmp(o)),'/',num2str(StimShft(o)),'/',num2str(FreqMod(o))];h=uicontrol('Style','Text','String',s,'Position',[5 60 100 15]);
              s=['dB ',num2str(dBbezug-isAttDB)];h=uicontrol('Style','Text','String',s,'Position',[5 45 100 15]);
              s=['Time  ',num2str(etime(clock,FirstT)/60,'%4.1f')];h=uicontrol('Style','Text','String',s,'Position',[5 30 100 15]);drawnow;              
                
              yFFT=fft(ASSRDat(1:FFTSize),FFTSize);Pyy=(sqrt(yFFT.*conj(yFFT))*2/FFTSize); 
              tFFT=0:FFTSize-1; tFFT=tFFT*(FreqRA16BS/FFTSize);
              p=(angle(yFFT));

              if isASSRMultiFreq==0              
                fx1=ASSRModFreq(n)-NoiseRange;
                fx2=ASSRModFreq(n)+NoiseRange;
                FFTfx1=uint32(fx1/((FreqRA16BS/FFTSize))); 
                FFTfx2=uint32(fx2/((FreqRA16BS/FFTSize)));

                fASSR1=ASSRModFreq(n)-ASSRrange;                      
                fASSR2=ASSRModFreq(n)+ASSRrange;
                FFTfASSR1=uint32(fASSR1/((FreqRA16BS/FFTSize)));
                FFTfASSR2=uint32(fASSR2/((FreqRA16BS/FFTSize)));
                
                ASSRInd=uint32( (ASSRModFreq(n))/((FreqRA16BS/FFTSize)) )+1;
                for mm=1:(FFTfASSR1-FFTfx1) noiseArray(mm)=Pyy(mm+FFTfx1-1); end;
                for mm=1:(FFTfx2-FFTfASSR2) noiseArray(mm+FFTfASSR1-FFTfx1)=Pyy(mm+FFTfASSR2-1); end;
                NoiseMean=mean(noiseArray);NoiseStd=std(noiseArray);ASSRMax=Pyy(ASSRInd);Diff2NoiseStd=(ASSRMax-NoiseMean-(2*NoiseStd));
                s=['+2*Std  ',num2str(Diff2NoiseStd,'%+12.1e')]; h=uicontrol('Style','Text','String',s,'Position',[5 120 100 15]);drawnow;
              else
                for iMult=1:SizeASSRFreqMulti(1,2) 
                  ASSRIndMult(iMult)=uint32( (ASSRModFMulti(iMult))/((FreqRA16BS/FFTSize)) )+1;

                  fASSR1Mult=ASSRModFMulti(iMult)-ASSRrange;                      
                  fASSR2Mult=ASSRModFMulti(iMult)+ASSRrange;
                  FFTfASSR1Mult=uint32(fASSR1Mult/((FreqRA16BS/FFTSize)));
                  FFTfASSR2Mult=uint32(fASSR2Mult/((FreqRA16BS/FFTSize)));
                  
                  fx1Mult=ASSRModFMulti(iMult)-NoiseRange;
                  fx2Mult=ASSRModFMulti(iMult)+NoiseRange;
                  FFTfx1Mult=uint32(fx1Mult/((FreqRA16BS/FFTSize))); 
                  FFTfx2Mult=uint32(fx2Mult/((FreqRA16BS/FFTSize)));

                  for mm=1:(FFTfASSR1Mult-FFTfx1Mult) noiseArray(mm)=Pyy(mm+FFTfx1Mult-1); end;
                  for mm=1:(FFTfx2Mult-FFTfASSR2Mult) noiseArray(mm+FFTfASSR1Mult-FFTfx1Mult)=Pyy(mm+FFTfASSR2Mult-1); end;
                  NoiseMeanMult(iMult)=mean(noiseArray);
                  NoiseStdMult(iMult)=std(noiseArray);
                  ASSRMaxMult(iMult)=Pyy(ASSRIndMult(iMult));
                  Diff2NoiseStdMult(iMult)=(ASSRMaxMult(iMult)-NoiseMeanMult(iMult)-(2*NoiseStdMult(iMult)));
                end;  
                fx1=min(ASSRModFMulti)-NoiseRange;
                fx2=max(ASSRModFMulti)+NoiseRange;
                fASSR1=min(ASSRModFMulti)-ASSRrange;
                fASSR2=max(ASSRModFMulti)+ASSRrange;
                FFTfx1=uint32(fx1/((FreqRA16BS/FFTSize))); 
                FFTfx2=uint32(fx2/((FreqRA16BS/FFTSize)));
                Diff2NoiseStd=0;
              end;  
                            
              subplot(3,2,1:2);plot(tFFT(5:uint32(FFTSize/8)),Pyy(5:uint32(FFTSize/8)));
              xlabel('Frequency (Hz)','FontSize',10);ylabel('Amplitude (|V|)','FontSize',10);
              subplot(3,2,3:4);plot(tFFT(FFTfx1:FFTfx2),Pyy(FFTfx1:FFTfx2));
              xlabel('Frequency (Hz)','FontSize',10);ylabel('Amplitude (|V|)','FontSize',10);              
              if isASSRMultiFreq==0 hold on; plot(tFFT(ASSRInd),Pyy(ASSRInd),'rx','MarkerSize',18); hold off;
              else
                hold on; for isMulti=1:SizeASSRFreqMulti(1,2) plot(tFFT(ASSRIndMult(isMulti)),Pyy(ASSRIndMult(isMulti)),'rx','MarkerSize',18); end; hold off;
              end;  
              subplot(3,6,14:15);plot(t(1:uint16(FreqRA16BS)),ASSRDat(1:uint16(FreqRA16BS)));
              xlabel('time (s)','FontSize',10);ylabel('Voltage(V)','FontSize',10);
              if isASSRMultiFreq==1
                for iMult=1:SizeASSRFreqMulti(1,2)
                  isASSRtrack=isASSRtrack+1;
                  if isASSRtrack==1
                    XLSArray(isASSRtrack,1) ={['fname']};
                    XLSArray(isASSRtrack,2) ={['trial']};
                    XLSArray(isASSRtrack,3) ={['fSample']};                  
                    XLSArray(isASSRtrack,4) ={['fCarrier']};                  
                    XLSArray(isASSRtrack,5) ={['fMod']};
                    XLSArray(isASSRtrack,6) ={['StimAmp']};
                    XLSArray(isASSRtrack,7) ={['StimShft']};
                    XLSArray(isASSRtrack,8) ={['Attenuator']};
                    XLSArray(isASSRtrack,9) ={['MedusaHP']};                  
                    XLSArray(isASSRtrack,10)={['StimAmp']};
                    XLSArray(isASSRtrack,11)={['NoiseMean']};
                    XLSArray(isASSRtrack,12)={['phase']};
                    XLSArray(isASSRtrack,13)={['2*std']};
                    XLSArray(isASSRtrack,14)={['Experiment']};                    
                  end;  
                  XLSArray(isASSRtrack+1,1 )={fileASSR};
                  XLSArray(isASSRtrack+1,2) ={j};
                  XLSArray(isASSRtrack+1,3) ={FreqRA16BS};
                  XLSArray(isASSRtrack+1,4) ={TragerFreqMulti(iMult)};
                  XLSArray(isASSRtrack+1,5) ={ASSRModFMulti(iMult)};
                  XLSArray(isASSRtrack+1,6) ={StimAmp(o)};
                  XLSArray(isASSRtrack+1,7) ={StimShft(o)};
                  XLSArray(isASSRtrack+1,8) ={dBbezug-isAttDB};
                  XLSArray(isASSRtrack+1,9) ={MedusaHP};
                  XLSArray(isASSRtrack+1,10)={Pyy(ASSRIndMult(iMult))};
                  XLSArray(isASSRtrack+1,11)={NoiseMeanMult(iMult)};
                  XLSArray(isASSRtrack+1,12)={(p(ASSRIndMult(iMult))*360/2/pi)*(-1)};
                  XLSArray(isASSRtrack+1,13)={Diff2NoiseStdMult(iMult)};
                  if SizeASSRFreqMulti(1,2)==1
                    Experiment='';
                    if strfind(sName,'4k')>0 Experiment=[Experiment '4k'];end;
                    if strfind(sName,'4K')>0 Experiment=[Experiment '4k'];end;                
                    if strfind(sName,'7k')>0 Experiment=[Experiment '7k'];end;
                    if strfind(sName,'7K')>0 Experiment=[Experiment '7k'];end;                
                    if strfind(sName,'10k')>0 Experiment=[Experiment '10k'];end;
                    if strfind(sName,'10K')>0 Experiment=[Experiment '10k'];end;
                    if strfind(sName,'15k')>0 Experiment=[Experiment '15k'];end;
                    if strfind(sName,'15K')>0 Experiment=[Experiment '15k'];end;            
                  else
                    Experiment='4k7k10k15k';
                  end;
                  XLSArray(isASSRtrack+1,14)={Experiment};
                end;
              end;  
              if (isASSR==1)
                isASSRtrack=isASSRtrack+1;
                if isASSRtrack==1
                  XLSArray(isASSRtrack,1)={['fname']};
                  XLSArray(isASSRtrack,2)={['trial']};
                  XLSArray(isASSRtrack,3)={['fSample']};                  
                  XLSArray(isASSRtrack,4)={['fCarrier']};                  
                  XLSArray(isASSRtrack,5)={['fMod']};
                  XLSArray(isASSRtrack,6)={['StimAmp']};
                  XLSArray(isASSRtrack,7)={['StimShft']};
                  XLSArray(isASSRtrack,8)={['Attenuator']};
                  XLSArray(isASSRtrack,9)={['MedusaHP']};                  
                  XLSArray(isASSRtrack,10)={['StimAmp']};
                  XLSArray(isASSRtrack,11)={['NoiseMean']};
                  XLSArray(isASSRtrack,12)={['phase']};
                  XLSArray(isASSRtrack,13)={['2*std']};
                end;  
                XLSArray(isASSRtrack+1,1)={fileBody};
                XLSArray(isASSRtrack+1,2)={j};
                XLSArray(isASSRtrack+1,3)={FreqRA16BS};
                XLSArray(isASSRtrack+1,4)={TragerFreq(m)};
                XLSArray(isASSRtrack+1,5)={ASSRModFreq(n)};
                XLSArray(isASSRtrack+1,6)={StimAmp(o)};
                XLSArray(isASSRtrack+1,7)={StimShft(o)};
                XLSArray(isASSRtrack+1,8)={dBbezug-isAttDB};
                XLSArray(isASSRtrack+1,9)={MedusaHP};
                XLSArray(isASSRtrack+1,10)={Pyy(ASSRInd)};
                XLSArray(isASSRtrack+1,11)={NoiseMean};
                XLSArray(isASSRtrack+1,12)={(p(ASSRInd)*360/2/pi)*(-1)};
                XLSArray(isASSRtrack+1,13)={(ASSRMax-NoiseMean-(2*NoiseStd))};
              end  
              if (isMTF==1) 
                Xn(isASSRtrack)=ASSRModFreq(n);
                ASSRInd=uint32(ASSRModFreq(n)/((FreqRA16BS/FFTSize)))+1;
                MaxASSR(isASSRtrack)=Pyy(ASSRInd);
                NoiseMeanMTF(isASSRtrack)=NoiseMean;
                subplot(3,2,6);plot(Xn,MaxASSR,Xn,NoiseMeanMTF);
                xlabel('Frequency (Hz)','FontSize',10);ylabel('Amplitude (|V|)','FontSize',10);
              else
                if (isASSR==1)
                  if (Diff2NoiseStd>0)
                    isASSRtrack=isASSRtrack+1;                      
                    Xn(isASSRtrack)=TragerFreq(m);
                    dBn(isASSRtrack)=dBbezug-isAttDB;
                    subplot(3,2,6);plot(Xn,dBn,'rx','MarkerSize',10);
                  end  
                end    
              end  
              drawnow;
            end
          end
        end
      end
    end  
  end
  invoke(RP1,'Halt');invoke(RA16BS,'Halt');invoke(PA5x1,'SetAtten',100);
  
  if (isMTF==1 )
    xlswrite([WavPath WavNameMTF],XLSArray,'Sheet1');
  end
  if (isASSR==1)
    xlswrite([WavPath WavName],XLSArray,'Sheet1');
  end  
  if (isASSRMultiFreq==1)
    xlswrite([WavPath WavName],XLSArray,'Sheet1');
  end   
  drawnow;
end